summaryrefslogtreecommitdiffstats
path: root/tests/data_plane/vpp_lite_topo/test_driver/src_dst.sh
diff options
context:
space:
mode:
authorFilip Tehlar <ftehlar@cisco.com>2016-09-16 15:11:01 +0200
committerFilip Tehlar <ftehlar@cisco.com>2016-10-24 15:59:06 +0200
commit5089c8126fe1d2c389ebc2e4b579612d6df15a69 (patch)
tree8666ad41a572a02ce39af3507beabfe23f3558ad /tests/data_plane/vpp_lite_topo/test_driver/src_dst.sh
parent1db8c38a6fa7fc692fe18bbd47eb2f87ec6b143b (diff)
Add source/dest tests
Change-Id: Idb3ec8dc48f16d4321701e405d8e76492cd7e9de Signed-off-by: Filip Tehlar <ftehlar@cisco.com>
Diffstat (limited to 'tests/data_plane/vpp_lite_topo/test_driver/src_dst.sh')
-rw-r--r--tests/data_plane/vpp_lite_topo/test_driver/src_dst.sh96
1 files changed, 96 insertions, 0 deletions
diff --git a/tests/data_plane/vpp_lite_topo/test_driver/src_dst.sh b/tests/data_plane/vpp_lite_topo/test_driver/src_dst.sh
new file mode 100644
index 0000000..14654ad
--- /dev/null
+++ b/tests/data_plane/vpp_lite_topo/test_driver/src_dst.sh
@@ -0,0 +1,96 @@
+source config.sh
+source odl_utils.sh
+source topologies/3_node_star.sh
+
+ODL_CONFIG_FILE1="map1.json"
+ODL_CONFIG_FILE2="map2.json"
+
+if [ "$1" == "clean" ] ; then
+ 3_node_star_topo_clean
+ exit 0
+fi
+
+if [[ $(id -u) != 0 ]]; then
+ echo "Error: run this as a root."
+ exit 1
+fi
+
+function send_ping_from_ns
+{
+ ip netns exec "${1}" "${2}" -w 20 -c 1 "${3}"
+ assert_rc_ok $? 3_node_star_topo_clean "No ICMP Response!"
+}
+
+function test_src_dst
+{
+ 3_node_star_topo_setup
+ post_curl "add-mapping" "map3.json"
+ post_curl "add-mapping" "map4.json"
+
+ maybe_pause
+
+ test_result=1
+
+ # send ping for first EID
+ send_ping_from_ns vpp-ns1 ${1} ${2}
+
+ # TODO assert counters
+
+ maybe_pause
+
+ # send ping for second EID
+ send_ping_from_ns vpp-ns3 ${1} ${2}
+
+ maybe_pause
+
+ # verify first tunnel still works
+ send_ping_from_ns vpp-ns1 ${1} ${2}
+
+ maybe_pause
+
+ # verify second tunnel still works
+ send_ping_from_ns vpp-ns3 ${1} ${2}
+ rc=$?
+
+ maybe_pause
+ 3_node_star_topo_clean
+ print_status $rc "No ICM response!"
+ exit $test_result
+}
+
+function test_src_dst_l2
+{
+ 3_node_star_topo_setup
+ post_curl "add-mapping" "map3.json"
+ post_curl "add-mapping" "map4.json"
+
+ maybe_pause
+
+ test_result=1
+
+ # send ping for first EID
+ send_ping_from_ns vpp-ns5 ${1} ${2}
+
+ # TODO assert counters
+
+ maybe_pause
+
+ # send ping for second EID
+ send_ping_from_ns vpp-ns8 ${1} ${2}
+
+ maybe_pause
+
+ # verify first tunnel still works
+ send_ping_from_ns vpp-ns5 ${1} ${2}
+
+ maybe_pause
+
+ # verify second tunnel still works
+ send_ping_from_ns vpp-ns8 ${1} ${2}
+ rc=$?
+
+ maybe_pause
+ 3_node_star_topo_clean
+ print_status $rc "No ICM response!"
+ exit $test_result
+}